

VOID PrintCDeclaration(LPSTR lpszLabelName, BYTE *lpData, UINT uDataSize)
{
CHAR szMsg[MAX_PATH];
UINT i,j=0;
sprintf_s(szMsg, sizeof(szMsg), "unsigned char %s[%d] = {", lpszLabelName, uDataSize);
UpdateLog(szMsg);

for(i=0; i<uDataSize; i++)
{
  if(j==0 && i != 0)
  {
   UpdateLog("          ");
  }
  sprintf_s(szMsg, sizeof(szMsg), "0x%02X", lpData[i]);
  UpdateLog(szMsg);
  
  j++;
  if(j == 16 && i+1 != uDataSize)
  {
   UpdateLog(",\r\n");
   j=0;
  }
  else if (i+1 != uDataSize)
  {
   UpdateLog(",");
  }
}

UpdateLog("};\r\n");
}
VOID PrintASMDeclaration(LPSTR lpszLabelName, BYTE *lpData, UINT uDataSize)
{
CHAR szMsg[MAX_PATH];
UINT i,j=0;
sprintf_s(szMsg, sizeof(szMsg), "_%s LABEL DWORD\r\n", lpszLabelName);
UpdateLog(szMsg);

for(i=0; i<uDataSize; i++)
{
  if(j==0)
  {
   UpdateLog(" db ");
  }
  sprintf_s(szMsg, sizeof(szMsg), "0%02Xh", lpData[i]);
  UpdateLog(szMsg);
  
  j++;
  if(j == 16)
  {
   UpdateLog("\r\n");
   j=0;
  }
  else
  {
   UpdateLog(", ");
  }
}

UpdateLog("\r\n");
}
VOID CreateHeaderFromBitmap(HWND hWnd)
{
CHAR CHMsg[MAX_PATH];

if(GetBitmapName(hWnd))
{
  ShowWindow(hLog, SW_HIDE);
  // We have the file name, now lets see if we can do something with it...
  UpdateLog("Loading bitmap.\r\n");
  
  HINSTANCE hInst = GetModuleHandle(NULL);
  HANDLE hBmp = LoadImage(hInst, szFileName, IMAGE_BITMAP, 0, 0,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
  if(!hBmp)
  {
   UpdateLog("Failed to load file.\r\n");
  }
  else
  {
   UpdateLog("Getting information about bitmap.\r\n");
   BITMAP bm;
   GetObject(hBmp, sizeof(BITMAP), &bm);
   sprintf_s(CHMsg, sizeof(CHMsg), "Bits Per Pixel: %d\r\n", bm.bmBitsPixel);
   UpdateLog(CHMsg);
   sprintf_s(CHMsg, sizeof(CHMsg), "Dimensions: %d x %d\r\n", bm.bmHeight, bm.bmWidth);
   UpdateLog(CHMsg);
   if((bm.bmBitsPixel * bm.bmPlanes ) <= 8)
   {
        HDC                hMemDC;
        HBITMAP    hOldBitmap;
        RGBQUAD    rgb[256];

        // Create a memory DC and select the DIBSection into it
        hMemDC = CreateCompatibleDC(NULL);
        hOldBitmap = (HBITMAP)SelectObject(hMemDC, hBmp);

        // Get the DIBSection's color table & its size
        INT SizeOfTable = GetDIBColorTable(hMemDC, 0, 256, rgb);

         // Calculate the size of required buffer.
        INT BitmapImageSize = (bm.bmHeight *
                  bm.bmWidth *
                  bm.bmBitsPixel) / 8;

        // Allocate memory.
        BYTE* pBitmapData = new BYTE[ BitmapImageSize ];
        ZeroMemory( pBitmapData, BitmapImageSize );
 
        // Get bitmap data.
           GetBitmapBits( (HBITMAP) hBmp, BitmapImageSize, pBitmapData );
 
        // Return our DC to its original state and delete it.
        SelectObject(hMemDC, hOldBitmap);
        DeleteDC(hMemDC);
 
        sprintf_s(CHMsg, sizeof(CHMsg), "Size: %d\r\n", BitmapImageSize);
        UpdateLog(CHMsg);
 
        sprintf_s(CHMsg, sizeof(CHMsg), "Entries in colour table: %d\r\n\r\n", SizeOfTable);
        UpdateLog(CHMsg);
 
        // Print ASM declaration
        UpdateLog(";*** Begin MASM declaration ***\r\n\r\n");
        PrintASMDeclaration("Palette", (BYTE*) &rgb, SizeOfTable * 4);
        PrintASMDeclaration("Bmp", pBitmapData, BitmapImageSize);
        UpdateLog(";*** End MASM declaration ***\r\n\r\n");

   // Print C declaration
        UpdateLog("//*** Begin C declaration ***\r\n\r\n");
        PrintCDeclaration("Palette", (BYTE*) &rgb, SizeOfTable * 4);
        PrintCDeclaration("Bmp", pBitmapData, BitmapImageSize);
        UpdateLog("//*** End C declaration ***\r\n\r\n");
        
        // Delete bitmap data after use.
        delete pBitmapData;
        pBitmapData = 0;

        UpdateLog("Completed processing bitmap file content.\r\n");
   }
   else
   {
        UpdateLog("Bitmap is greyscale, no colour table available.\r\n");
   }
   // Finally free the object resource for the loaded bitmap
   DeleteObject(hBmp);
  }
}
ShowWindow(hLog, SW_SHOWNORMAL);

}